package Team5.SmartTowns;

import org.junit.jupiter.api.AfterEach;
//import org.junit.jupiter.api.BeforeAll;
//import org.junit.jupiter.api.BeforeEach;


import org.junit.After;
import org.junit.Before;


//import org.junit.Test; //- using this stops initialisation error, and runs properly, but breaks firefox driver
import org.junit.jupiter.api.Test; //works but initialisation error
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.extension.ExtendWith;
import org.junit.runner.RunWith;

import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.firefox.FirefoxOptions;
import org.openqa.selenium.support.ui.Select;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Profile;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.context.junit4.SpringRunner;

import io.github.bonigarcia.wdm.WebDriverManager;


import static javax.swing.text.html.CSS.getAttribute;
import static org.junit.Assert.assertTrue;
import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;

//@RunWith(SpringRunner.class)
@ExtendWith(SpringExtension.class)
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
//@ActiveProfiles("test")
public class FirefoxDriverPagesTests {
    @Value("${local.server.port}")
    private int port;

    WebDriver webDriver;

    @BeforeAll // setupFirefoxDriver
    static void setupClass() {
        WebDriverManager.firefoxdriver().setup();
    }

    @BeforeEach
    void setupTest() {
        FirefoxOptions options = new FirefoxOptions();
//        options.addArguments("--headless");
        webDriver = new FirefoxDriver(options);
//        webDriver = new FirefoxDriver();
    }
    @AfterEach
    void teardown() {
        webDriver.quit();
    }


    @Test
    public void pageSetupTest() {
    }

    @Test
    public void testHomePageContents() {
        this.webDriver.get("http://localhost:" + Integer.toString(port) + "/mobile-home");
//        assertEquals(1,1);
        assertTrue(webDriver.findElement(By.cssSelector("main")).getText().contains("Welcome to VZTA Smart Towns!"));


    }
//test false entries, log ina dn log out?
@Test
@DirtiesContext
public void testingEntireFeature(){
        //homePage
    this.webDriver.get("http://localhost:" + Integer.toString(port) + "/mobile-home");
    assertTrue(webDriver.findElement(By.cssSelector("main")).getText().contains("Welcome to VZTA Smart Towns!"));
    assertTrue(webDriver.findElements(By.xpath("/html/body/main/div[1]/a[1]/button")).size() > 0);
    assertTrue(webDriver.findElement(By.xpath("/html/body/main/div[1]/a[1]/button")).getText().contains("Submit Landmark"));
    this.webDriver.findElement(By.xpath("/html/body/main/div[1]/a[1]/button")).click();
    //Landmark Sign Up Form
    assertTrue(webDriver.findElement(By.cssSelector("main form h1")).getText().contains("Interested in joining our trails? Sign up Here!"));
    this.webDriver.findElement(By.name("landmarkName")).sendKeys("MockLocation");
    this.webDriver.findElement(By.name("landmarkEmail")).sendKeys("MockAddress@Contact.co.uk");
    this.webDriver.findElement(By.name("landmarkDescription")).sendKeys("This is a mock description of this business.");
    new Select(this.webDriver.findElement(By.name("landmarkLocation"))).selectByVisibleText("Caerphilly");
    new Select(this.webDriver.findElement(By.name("trailID"))).selectByVisibleText("(Caerphilly) Heritage Trail");
    assertTrue(webDriver.findElement(By.cssSelector("main form ")).getText().contains("Submit"));
    assertTrue(webDriver.findElements(By.xpath("/html/body/main/form/button")).size() > 0);
    this.webDriver.findElement(By.xpath("/html/body/main/form/button")).click();
    //return to home page
    assertTrue(webDriver.findElement(By.cssSelector("main div")).getText().contains("Welcome to VZTA Smart Towns!"));
    assertFalse(webDriver.findElement(By.cssSelector("main div")).getText().contains("Review Landmark!"));
    //Log In as Administrator (This user-feature is not what's being tested, as such it won't be covered apart from here)
    assertTrue(webDriver.findElement(By.cssSelector("header nav")).getText().contains("Log In"));
    assertTrue(webDriver.findElement(By.xpath("/html/body/header/nav/ul/li[4]")).getText().contains("Log In"));
//    assertEquals(webDriver.findElement(By.xpath("/html/body/header/nav/ul/li[4]")).getAttribute("href"),("localhost:" + Integer.toString(port) + "/login"));
    assertTrue(webDriver.findElements(By.xpath("/html/body/header/nav/ul/li[4]")).size() > 0);
    this.webDriver.findElement(By.xpath("/html/body/header/nav/ul/li[4]/a")).click();

    //sign in
    assertTrue(webDriver.findElement(By.xpath("/html/body/main/div/div[2]/h1")).getText().contains("Sign In"));
    this.webDriver.findElement(By.xpath("/html/body/main/div/div[2]/form/label[1]/input")).sendKeys("Admin");
    this.webDriver.findElement(By.xpath("/html/body/main/div/div[2]/form/label[2]/input")).sendKeys("admin");
    assertTrue(webDriver.findElement(By.xpath("/html/body/main/div/div[2]/form/button")).getText().contains("SIGN IN"));
    assertTrue(webDriver.findElements(By.xpath("/html/body/main/div/div[2]/form/button")).size() > 0);
    this.webDriver.findElement(By.xpath("/html/body/main/div/div[2]/form/button")).click();

    //check review shows for admin
    assertTrue(webDriver.findElement(By.cssSelector("main div")).getText().contains("Review Landmark!"));
    assertTrue(webDriver.findElements(By.xpath("/html/body/main/div[1]/a[2]")).size() > 0);
    this.webDriver.findElement(By.xpath("/html/body/main/div[1]/a[2]")).click();


    assertTrue(webDriver.findElement(By.xpath("/html/body/main/section/h2")).getText().contains("To Be Approved"));
    assertTrue(webDriver.findElement(By.cssSelector("main h1")).getText().contains("Locations To Be Approved:"));
//todo FIX THIS!!
    assertTrue(webDriver.findElement(By.cssSelector("main table tbody ")).getText().contains("MockLocation (0103)"));
    assertTrue(webDriver.findElement(By.cssSelector("main section table tbody")).getText().contains("MockAddress@Contact.co.uk"));
    assertTrue(webDriver.findElement(By.cssSelector("main section table tbody")).getText().contains("This is a mock description of this business."));
    //Can't test Caerphilly;ly as others already there todo? look into Risca
    //todo test verification of this form
    new Select(this.webDriver.findElement(By.name("locationName"))).selectByVisibleText("MockLocation (0103)");
    this.webDriver.findElement(By.name("locationCoordsLat")).sendKeys("51.57815");
    this.webDriver.findElement(By.name("locationCoordsLong")).sendKeys("-3.22510");
    assertTrue(webDriver.findElement(By.xpath("/html/body/main/form/button")).getText().contains("Submit"));
    assertTrue(webDriver.findElements(By.xpath("/html/body/main/form/button")).size() > 0);
    this.webDriver.findElement(By.xpath("/html/body/main/form/button")).click();

    assertTrue(webDriver.findElement(By.cssSelector("main")).getText().contains("Welcome to VZTA Smart Towns!"));
    this.webDriver.findElement(By.xpath("/html/body/main/div[1]/a[2]")).click();
    assertFalse(webDriver.findElement(By.cssSelector("main table")).getText().contains("MockLocation (0103)"));

    assertTrue(webDriver.findElements(By.xpath("/html/body/header/nav/ul/li[1]")).size() > 0); //todo fix tghis bit
    this.webDriver.findElement(By.xpath("/html/body/header/nav/ul/li[1]/a")).click();
    assertTrue(webDriver.findElement(By.cssSelector("main")).getText().contains("Welcome to VZTA Smart Towns!"));



}
}
